Attribute VB_Name = "MainCode"
'   FtpContentChecker
'   =================
'
'coded by (c) aLBERT
Option Explicit
Global Const ProgrammName As String = "FtpContentChecker"

Global Unloading As Boolean
Global ProgramIsRunning As Boolean

Sub Main()
 Unloading = False
 ProgramIsRunning = True
  
 If App.PrevInstance Then 'Programm luft bereits?
    'MsgBox "Dieses Programm kann nicht mehrmals auf demselben PC gestartet werden.", vbCritical, "Fehler"
    'End
 End If
 
 DefineConstants
 init_Debug
 init_TimerModul
 show_DebugForm
 set_CreateLogState 1
 CheckCommandParameter
 Init_MainInterface
 
 Log "Programmstart"
 If GetOption(StartCounterFile, "0") = "0" Then
  Log "first start"
  SetOption StartCounterFile, "1"
 Else
  SetOption StartCounterFile, LTrim$(RTrim$(Str$(Val(GetOption(StartCounterFile)) + 1)))
 End If
 
 Log "LoadStandard"
 LoadStandard
 
 Log "ready to show me"
 ShowMe
 
 Log "Start-Prozess ready"
End Sub

Private Sub CheckCommandParameter()
 ReDim commands(1) As String
 Dim Temp As String
 Temp = LTrim$(RTrim$(Command$))
 Dim X As Long
 Dim InA As Boolean 'in Anfhrungsstrichen (")
 InA = False
 For X = 1 To Len(Temp)
  Select Case Mid$(Temp, X, 1)
   Case Chr$(34) '"
    InA = Not InA
   Case " "
    If InA Then
     commands(UBound(commands)) = commands(UBound(commands)) _
                                + Mid$(Temp, X, 1)
    Else
     If commands(UBound(commands)) <> "" Then
      ReDim Preserve commands(UBound(commands) + 1) As String
     End If
    End If
   Case Else
    commands(UBound(commands)) = commands(UBound(commands)) _
                               + Mid$(Temp, X, 1)
  End Select
 Next
 If commands(UBound(commands)) = "" Then
  ReDim Preserve commands(UBound(commands) - 1) As String
 End If

 For X = 1 To UBound(commands)
  Select Case Left$(commands(X), 1)
   Case "\", "-", "/"
    commands(X) = LTrim$(RTrim$(Right$(commands(X), Len(commands(X)) - 1)))
  End Select
  If AZLeftGleich(UCase$(commands(X)), "DEBUGFILE") Then
   enable_ProzessDebugFile_Engine
  ElseIf AZLeftGleich(UCase$(commands(X)), "DEBUG") Then
   show_DebugForm
  ElseIf AZLeftGleich(UCase$(commands(X)), "LOG") Then
   set_CreateLogState Val(Right$(commands(X), Len(commands(X)) - 3))
  ElseIf AZLeftGleich(UCase$(commands(X)), "PROZESSINFO") Then
   enable_ProzessInfo
  End If
 Next
End Sub

Private Sub LoadStandard()
    Log "loading MainForm ..."
    Load MainForm
    Log "loading ready"
End Sub

Private Sub ShowMe()
    MainForm.Show
End Sub

Public Sub ExitProg()
    Log "Unloading now..."
    Unloading = True
    UnInit_MainInterface
    Dim F As Form
    For Each F In Forms
        'If Not TypeOf f Is DebugForm Then
        If (Not TypeOf F Is WinsockServer_Form) _
        And (Not TypeOf F Is WinsockClient_Form) Then 'sollten automatisch entladen werden
            Unload F
        End If
        'End If
    Next
    Log "Exit"
End Sub

Public Sub RestartProg()
    ExitProg
    Log "Restart"
    Shell Verz + App.EXEName + ".exe " + Command$, vbNormalFocus
End Sub

Public Function FormsCount() As Long
    Dim F As Form
    Dim i As Long
    i = 0
    For Each F In Forms
        If (Not TypeOf F Is DebugForm) _
        And (Not TypeOf F Is WinsockServer_Form) _
        And (Not TypeOf F Is WinsockClient_Form) Then
           i = i + 1
        End If
    Next
    FormsCount = i
End Function
